﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PSOCore
{
    class MaxParticle:Particle
    {
        public MaxParticle(double[] position, double fitness, double[] velocity, double[] bestPosition, double bestFitness)
            : base(position,fitness, velocity, bestPosition,bestFitness)
        { 

        }
        public void MaximalizeUpdateRychlost(ref MaxParticle actualParticle, MaxSwarm swarm, ref double[] newVelocity,
           ref double[] newPosition, ref double[] bestGlobalPosition, ref double bestGlobalFitness)
        {
            double r1, r2, newFitness;
            for (int j = 0; j < actualParticle.rychlost.Length; ++j) 
            {
                r1 = _rnd.NextDouble();
                r2 = _rnd.NextDouble();

                newVelocity[j] = (Swarm.vaha * actualParticle.rychlost[j]) +
                  (Swarm.constP * r1 * (actualParticle.bestPozice[j] - actualParticle.pozice[j])) +
                  (Swarm.constG * r2 * (bestGlobalPosition[j] - actualParticle.pozice[j]));

                if (newVelocity[j] < swarm.minR)
                    newVelocity[j] = swarm.minR;
                else if (newVelocity[j] > swarm.maxR)
                    newVelocity[j] = swarm.maxR;
            }

            newVelocity.CopyTo(actualParticle.rychlost, 0);

            for (int j = 0; j < actualParticle.pozice.Length; ++j)
            {
                newPosition[j] = actualParticle.pozice[j] + newVelocity[j];
                if (newPosition[j] < MaxSwarm.minX)
                    newPosition[j] = MaxSwarm.minX;
                else if (newPosition[j] > MaxSwarm.maxX)
                    newPosition[j] = MaxSwarm.maxX;
            }

            newPosition.CopyTo(actualParticle.pozice, 0);
            newFitness = swarm.fn.Function(newPosition);
            actualParticle.fitness = newFitness;
            if (newFitness > actualParticle.bestFitness)
            {
                newPosition.CopyTo(actualParticle.bestPozice, 0);
                actualParticle.bestFitness = newFitness;
            }
            if (newFitness > bestGlobalFitness)
            {
                newPosition.CopyTo(bestGlobalPosition, 0);
                bestGlobalFitness = newFitness;
            }
        }
    }
}
