﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PSOCore
{
    public class MinSwarm:Swarm
    {
        public double bestGlobalFitness = double.MaxValue; 
        MinParticle[] minswarm;
        public MinSwarm(int dim, int numberParticles)
            : base(dim, numberParticles)
        { 
   
            minswarm = new MinParticle[numberParticles];
        }
        public override void inicializace(Int32 fce)
        {
            fn = new FunctionBase(fce);
            for (int i = 0; i < minswarm.Length; ++i) 
            {
                double[] randomPosition = new double[pocetDimenzi];
                for (int j = 0; j < randomPosition.Length; ++j)
                {
                    double lo = minX;
                    double hi = maxX;
                    randomPosition[j] = (hi - lo) * _rnd.NextDouble() + lo;
                }

                double fitness = fn.Function(randomPosition);
                double[] randomVelocity = new double[pocetDimenzi];

                for (int j = 0; j < randomVelocity.Length; ++j)
                {
                    double lo = -1.0 * Math.Abs(maxX - minX);
                    double hi = Math.Abs(maxX - minX);
                    randomVelocity[j] = (hi - lo) * _rnd.NextDouble() + lo;
                }
                minswarm[i] = new MinParticle(randomPosition, fitness, randomVelocity, randomPosition, fitness);


                if (minswarm[i].fitness < this.bestGlobalFitness)
                {
                    this.bestGlobalFitness = minswarm[i].fitness;
                    minswarm[i].pozice.CopyTo(bestGlobalPozice, 0);
                }
            } 
            this.minR = -1.0 * maxX;
            this.maxR = maxX;
        }
        public override void psoLoop()
        {
            FormBar formular_nacitani = new FormBar();
            formular_nacitani.Show();
            Swarm.reseni += Environment.NewLine;
            Swarm.reseni += "Průběh výpočtu";
            Swarm.reseni += Environment.NewLine;
            Swarm.reseni += "Rychlost a pozice náhodné částice";
            Swarm.reseni += Environment.NewLine;
            while (iteraci  < pocetIteraci)
            {

                ++iteraci;
                double[] newVelocity = new double[pocetDimenzi];
                double[] newPosition = new double[pocetDimenzi];

                for (int i = 0; i < minswarm.Length; ++i) 
                {
                    minswarm[i].MinimizeUpdateRychlost(ref minswarm[i], this, ref newVelocity,
                    ref newPosition, ref this.bestGlobalPozice, ref this.bestGlobalFitness);
                }
                if (iteraci%5==0){
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "Iterace " + iteraci;
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += minswarm[0].ToString();
                }
                pbar = this.SetPBValue();

                formular_nacitani.nastav(pbar);
                if (formular_nacitani.vratpBar() == 100)
                {
                    formular_nacitani.Dispose();
                    formular_nacitani.Close();
                    break;
                }
            }           
            Swarm.reseni += "Nejlepší nalezená pozice ";
            for (int l = 0; l < this.bestGlobalPozice.Length; l++)
            {
                Swarm.reseni += this.bestGlobalPozice[l] + " | ";
            }
            Swarm.reseni += Environment.NewLine;
            Swarm.reseni += "Nejvyšší dosažené fitness ze všech částic " + this.bestGlobalFitness;
            Swarm.reseni += Environment.NewLine;
            Swarm.bestValue = this.bestGlobalFitness;
        }
    }
}
