﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PSOCore
{
    public class Swarm
    {
        #region StatickeVlastnosti
        protected static Random _rnd = new Random();
        protected static double pbar = 0;
        public static double pocetIteraci = 10;
        public static double pocetCastic = 10;
        public static int pocetDimenzi = 2;
        public static double minX = 0.0;
        public static double maxX = 100.0;
          public static double vaha = 0.75; // váha 
          public static double constP = 2; // osobni konstanta
          public static double constG = 2; // globální konstanta
          public static string reseni = "";
          public static string sekvence = "";
          public static double GB = 0;
          public static string[] vypis;
          public static string elapsedtime;
          public static double bestValue = 0;
          public static string spolecneRadky = "";
        #endregion

        #region Vlastnosti
        protected int iteraci = 0;
        public FunctionBase fn;

        public double[] bestGlobalPozice;
        public double bestGlobalFitness ; 

        Particle[] swarm;

        public double minR;
        public double maxR;
        #endregion

        #region Metody
        public Swarm(int dim, int numberParticles)
        { 
            bestGlobalPozice = new double[pocetDimenzi];
            Swarm.pocetCastic = numberParticles;
            swarm = new Particle[numberParticles];
            
        }
        public virtual void inicializace(Int32 fce) {
            fn = new FunctionBase(fce);
            pbar = 0;
            for (int i = 0; i < swarm.Length; ++i) 
            {
                double[] randomPosition = new double[pocetDimenzi];
                for (int j = 0; j < randomPosition.Length; ++j)
                {
                    double lo = minX;
                    double hi = maxX;
                    randomPosition[j] = (hi - lo) * _rnd.NextDouble() + lo; 
                }

                double fitness = fn.Function(randomPosition);
                double[] randomVelocity = new double[pocetDimenzi];

                for (int j = 0; j < randomVelocity.Length; ++j)
                {
                    double lo = -1.0 * Math.Abs(maxX - minX);
                    double hi = Math.Abs(maxX - minX);
                    randomVelocity[j] = (hi - lo) * _rnd.NextDouble() + lo;
                }
                swarm[i] = new Particle(randomPosition, fitness, randomVelocity, randomPosition, fitness);

                if (swarm[i].fitness > bestGlobalFitness)
                {
                    bestGlobalFitness = swarm[i].fitness;
                    swarm[i].pozice.CopyTo(bestGlobalPozice, 0);
                }
            } 
            this.minR = -1.0 * maxX;
            this.maxR = maxX;
        }

        public virtual void psoLoop()
        {
            FormBar a = new FormBar();
            a.Show();
            
            DialogResult result = a.ShowDialog();
            while (iteraci < pocetIteraci)
            {               
                ++iteraci;
                double[] newVelocity = new double[pocetDimenzi];
                double[] newPosition = new double[pocetDimenzi];


                for (int i = 0; i < swarm.Length; ++i) 
                {
                    swarm[i].UpdateRychlost(ref swarm[i],this, ref newVelocity,
                    ref newPosition, ref this.bestGlobalPozice, ref this.bestGlobalFitness);
                }
            }
        }
        public int SetPBValue()
        {
            double posun = pocetIteraci / 100;
            posun= iteraci/posun;
            return (int)(Math.Round(posun,0));
        }
        #endregion
    }
}
