﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using PSOCore;
using System.Diagnostics;
using System.Threading;
using System.IO;
using System.Globalization;
using PSOCore;

namespace PSO
{
    public partial class Form1 : Form
    {
        List<ListViewItem> item = new List<ListViewItem>();
        Stopwatch stopWatch = new Stopwatch();
        public Swarm s;
        static public Form_Nastaveni f;
        static private int id = 0;
        public List<List<int>> realnadatastore = new List<List<int>>();
        public List<List<char>> realnadatastorenominalni = new List<List<char>>();
        public List<List<bool>> realnadatastorebinarni = new List<List<bool>>();
        public double zapornaHodnotaSwarmPozice;


        public Form1()
        {
            InitializeComponent();
            comboBox_funkce.Visible = false;
            label_vzorec.Visible = false;
            vlozitRealnaData.Visible = false;
            textBoxpocetNumDimenzi.Visible = false; 
            labelpocetdimenziNum.Visible = false; 
            comboBox_funkce.Items.Add("Eggholder funkce 2D");
            comboBox_funkce.Items.Add("Schwefel funkce");
            comboBox_funkce.Items.Add("Rastrigin funkce");
            comboBox_funkce.Items.Add("Easom funkce 2D");
            comboBox_typ.Items.Add("Maximum");
            comboBox_typ.Items.Add("Minimum");
            comboBox_funkce.SelectedIndex = 0;
            comboBox_typ.SelectedIndex = 0;
            listView_vysledky.View = View.Details;
            listView_vysledky.GridLines = true;
            listView_vysledky.FullRowSelect = true;
            listView_vysledky.Columns.Add("Pořadí",80);
            listView_vysledky.Columns.Add("Typ",80);
            listView_vysledky.Columns.Add("Nalezené pozice", 320);
            listView_vysledky.Columns.Add("Nalezené řešení", 80);
            listView_vysledky.Columns.Add("RunTime", 80);
        }

        private void button_spust_Click(object sender, EventArgs e)
        {
                Swarm.reseni = "";
                ++id;
                //nastaveni pro funkci ktere data bude zpracovavat
                zvoltyp();
                if (textBoxpocetNumDimenzi.Visible == true)
                {
                    Swarm.pocetDimenzi = Convert.ToInt32(textBoxpocetNumDimenzi.Text);
                }
                //
                item.Add(new ListViewItem(Convert.ToString(id)));
                string a = comboBox_typ.SelectedIndex.ToString();
                if ((NumerickaData.Checked == true) && (RadioUmelaData.Checked == true))
                {
                    if (a == "0")
                    {
                        s = new MaxSwarm(2, Convert.ToInt32(Swarm.pocetCastic));
                        item[id - 1].SubItems.Add("Maximum");
                    }
                    else
                    {
                        s = new MinSwarm(2, Convert.ToInt32(Swarm.pocetCastic));
                        item[id - 1].SubItems.Add("Minimum");
                    }
                    Int32 fce = Convert.ToInt32(comboBox_funkce.SelectedIndex.ToString());
                    stopWatch.Reset();
                    stopWatch.Start();
                    s.inicializace(fce);
                    s.psoLoop();
                    stopWatch.Stop();
                    string vysledky = "";
                    for (int i = 0; i < s.bestGlobalPozice.Length; ++i)
                    {
                        vysledky += s.bestGlobalPozice[i].ToString("F5") + " | ";
                    }
                    item[id - 1].SubItems.Add(vysledky);
                    item[id - 1].SubItems.Add(Convert.ToString(Swarm.bestValue.ToString("F5")));
                    // Console.WriteLine("s.bestGlobalFitness " + s.bestGlobalFitness);
                    TimeSpan ts = stopWatch.Elapsed;
                    Swarm.elapsedtime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10);
                    item[id - 1].SubItems.Add(Swarm.elapsedtime);
                    listView_vysledky.Items.AddRange(new ListViewItem[] { item[id - 1] });
                    listView_vysledky.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
                    Swarm.reseni += "Čas výpočtu " + Swarm.elapsedtime;
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "V definičním oboru hodnot od " + Swarm.minX + " do " + Swarm.maxX + ". Nalezeno řešení pro " + label_vzorec.Text;
                    Swarm.reseni += Environment.NewLine;
                    //vynulovani
                    //Console.WriteLine("s.bestGlobalFitness " + s.bestGlobalFitness);
                    // Console.WriteLine(Swarm.reseni);
                    Swarm.GB = 0; Swarm.sekvence = ""; Swarm.elapsedtime = ""; Swarm.bestValue = 0;
                    //vynulovani
                }
                if ((NumerickaData.Checked == true) && (RadioRealnaData.Checked == true))
                {
                    if (a == "0")
                    {
                        s = new MaxSwarm(2, Convert.ToInt32(Swarm.pocetCastic));
                        item[id - 1].SubItems.Add("Maximum");
                    }
                    else
                    {
                        s = new MinSwarm(2, Convert.ToInt32(Swarm.pocetCastic));
                        item[id - 1].SubItems.Add("Minimum");
                    }

                    stopWatch.Reset();
                    stopWatch.Start();
                    s.inicializace(Convert.ToInt32(comboBox_funkce.SelectedIndex.ToString()));
                    s.psoLoop();
                    stopWatch.Stop();
                    string vysledky = "";
                    double[] pozice = new double[s.bestGlobalPozice.Length];
                    Swarm.reseni += "Pozice ve zdrojovém souboru se ";
                    for (int i = 0; i < s.bestGlobalPozice.Length; ++i)
                    {
                        pozice[i] = (((FunctionBase.realnadatastore[i].Count - 1) / Swarm.maxX) * s.bestGlobalPozice[i]);
                        vysledky += "Pozice: " + Math.Round(pozice[i]) + " (" + FunctionBase.realnadatastore[i][Convert.ToInt32(Math.Round(pozice[i]))] + ") | ";
                        Swarm.reseni += "p" + (i + 1) + ": " + (Math.Round(pozice[i]) + 1) + " ";
                    }
                    item[id - 1].SubItems.Add(vysledky);
                    item[id - 1].SubItems.Add(Convert.ToString(FunctionBase.ZjistiVysledek(pozice)));
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "Po přepočítání výsledků. Výsledek fitness funkce nejlepší nalezené pozice " + Convert.ToString(FunctionBase.ZjistiVysledek(pozice));
                    TimeSpan ts = stopWatch.Elapsed;
                    Swarm.elapsedtime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10);
                    item[id - 1].SubItems.Add(Swarm.elapsedtime);
                    listView_vysledky.Items.AddRange(new ListViewItem[] { item[id - 1] });
                    listView_vysledky.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "Čas výpočtu " + Swarm.elapsedtime;
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "Z načtených dat. Nalezeno řešení pro " + label_vzorec.Text;
                    Swarm.reseni += Environment.NewLine;
                    //vynulovani
                    //  Console.WriteLine(Swarm.reseni);
                    Swarm.GB = 0; Swarm.sekvence = ""; Swarm.elapsedtime = ""; Swarm.bestValue = 0;
                    //vynulovani
                }
                if ((NominalniData.Checked == true) && (RadioUmelaData.Checked == true))
                {
                    if (generujuNominalni())
                    {
                        s = new MaxSwarm(2, Convert.ToInt32(Swarm.pocetCastic));
                        item[id - 1].SubItems.Add("Maximum");
                        stopWatch.Reset();
                        stopWatch.Start();
                        s.inicializace(Convert.ToInt32(comboBox_funkce.SelectedIndex.ToString()));
                        s.psoLoop();
                        stopWatch.Stop();
                        upravVysledky();
                        item[id - 1].SubItems.Add("Na řádcích " + Swarm.spolecneRadky);
                        item[id - 1].SubItems.Add(Swarm.sekvence);
                        TimeSpan ts = stopWatch.Elapsed;
                        Swarm.elapsedtime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10);
                        item[id - 1].SubItems.Add(Swarm.elapsedtime);
                        listView_vysledky.Items.AddRange(new ListViewItem[] { item[id - 1] });
                        listView_vysledky.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
                        Swarm.reseni += "Čas výpočtu " + Swarm.elapsedtime;
                        Swarm.reseni += Environment.NewLine;
                        //vynulovani
                        Console.WriteLine(Swarm.reseni);
                        Swarm.GB = 0; Swarm.sekvence = ""; Swarm.elapsedtime = ""; Swarm.spolecneRadky = "";
                        //vynulovani
                    }
                }
                if ((NominalniData.Checked == true) && (RadioRealnaData.Checked == true))
                {
                    s = new MaxSwarm(2, Convert.ToInt32(Swarm.pocetCastic));
                    item[id - 1].SubItems.Add("Maximum");
                    stopWatch.Reset();
                    stopWatch.Start();
                    s.inicializace(Convert.ToInt32(comboBox_funkce.SelectedIndex.ToString()));
                    s.psoLoop();
                    stopWatch.Stop();
                    item[id - 1].SubItems.Add("Na řádcích " + Swarm.spolecneRadky);
                    item[id - 1].SubItems.Add(Swarm.sekvence);                   
                    TimeSpan ts = stopWatch.Elapsed;
                    Swarm.elapsedtime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10);
                    item[id - 1].SubItems.Add(Swarm.elapsedtime);
                    listView_vysledky.Items.AddRange(new ListViewItem[] { item[id - 1] });
                    listView_vysledky.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
                    Swarm.reseni += "Čas výpočtu " + Swarm.elapsedtime;
                    Swarm.reseni += Environment.NewLine;
                    //vynulovani
                   // Console.WriteLine(Swarm.reseni);
                    Swarm.GB = 0; Swarm.sekvence = ""; Swarm.elapsedtime = ""; Swarm.spolecneRadky = "";
                    //vynulovani
                }
                if ((BinarniData.Checked == true) && (RadioRealnaData.Checked == true))
                {
                    s = new MaxSwarm(2, Convert.ToInt32(Swarm.pocetCastic));
                    item[id - 1].SubItems.Add("Maximum");
                    stopWatch.Reset();
                    stopWatch.Start();
                    s.inicializace(Convert.ToInt32(comboBox_funkce.SelectedIndex.ToString()));
                    s.psoLoop();
                    stopWatch.Stop();
                    item[id - 1].SubItems.Add("Na řádcích " + Swarm.spolecneRadky);
                    item[id - 1].SubItems.Add(Swarm.sekvence);
                    TimeSpan ts = stopWatch.Elapsed;
                    Swarm.elapsedtime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10);
                    item[id - 1].SubItems.Add(Swarm.elapsedtime);
                    listView_vysledky.Items.AddRange(new ListViewItem[] { item[id - 1] });
                    listView_vysledky.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);
                    Swarm.reseni += "Čas výpočtu " + Swarm.elapsedtime;
                    Swarm.reseni += Environment.NewLine;
                    //vynulovani
                    Console.WriteLine(Swarm.reseni);
                    Swarm.GB = 0; Swarm.sekvence = ""; Swarm.elapsedtime = ""; Swarm.spolecneRadky = "";
                    //vynulovani
                }
                if ((BinarniData.Checked == true) && (RadioUmelaData.Checked == true))
                {
                    if (generujuBinarni())
                    {
                        s = new MaxSwarm(2, Convert.ToInt32(Swarm.pocetCastic));
                        item[id - 1].SubItems.Add("Maximum");
                        stopWatch.Reset();
                        stopWatch.Start();
                        s.inicializace(Convert.ToInt32(comboBox_funkce.SelectedIndex.ToString()));
                        s.psoLoop();
                        stopWatch.Stop();
                        upravVysledky();
                        item[id - 1].SubItems.Add("Na řádcích " + Swarm.spolecneRadky);
                        item[id - 1].SubItems.Add(Swarm.sekvence);
                        TimeSpan ts = stopWatch.Elapsed;
                        Swarm.elapsedtime = String.Format("{0:00}:{1:00}:{2:00}.{3:00}", ts.Hours, ts.Minutes, ts.Seconds, ts.Milliseconds / 10);
                        item[id - 1].SubItems.Add(Swarm.elapsedtime);
                        listView_vysledky.Items.AddRange(new ListViewItem[] { item[id - 1] });
                        listView_vysledky.AutoResizeColumns(ColumnHeaderAutoResizeStyle.ColumnContent);

                        Swarm.reseni += "Čas výpočtu " + Swarm.elapsedtime;
                        Swarm.reseni += Environment.NewLine;
                        //vynulovani
                        Console.WriteLine(Swarm.reseni);
                        Swarm.GB = 0; Swarm.sekvence = ""; Swarm.elapsedtime = ""; Swarm.spolecneRadky = "";
                        //vynulovani
                    }
                }
        }

        private void konecToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void nastaveniToolStripMenuItem_Click(object sender, EventArgs e)
        {
            f = new Form_Nastaveni();
            f.Show();
            
        }

        private void exportToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveFileDialog_Export.CreatePrompt = true;
            saveFileDialog_Export.OverwritePrompt = true;
            saveFileDialog_Export.FileName = "myText";
            saveFileDialog_Export.DefaultExt = "txt";
            saveFileDialog_Export.Filter =
                "Text files (*.txt)|*.txt|All files (*.*)|*.*";
            saveFileDialog_Export.InitialDirectory =
                Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            DialogResult result = saveFileDialog_Export.ShowDialog();
            string file;
            if (result == DialogResult.OK)
            {
                file = saveFileDialog_Export.FileName;
                using (StreamWriter writer = new StreamWriter(file))
                {
                    writer.Write(Swarm.reseni);
                }
            }
            Swarm.reseni = "";
        }

        private void comboBox_funkce_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (comboBox_funkce.SelectedIndex)
            {
                case 0:
                    label_vzorec.Text = "Globální minimum v Df<-512; 512> je f(x) = -959,6407 na pozici x=(512; 404,2319).";
                    Swarm.pocetDimenzi = 2;textBoxpocetNumDimenzi.Visible = false; labelpocetdimenziNum.Visible = false;
                    break;
                case 1:
                    label_vzorec.Text = "Globální minimum v Df<-500;...;500> je f(x) = 0 na pozici x=(420,8697;...;420,8697).";
                    textBoxpocetNumDimenzi.Visible = true; labelpocetdimenziNum.Visible = true;
                    break;
                case 2:
                    label_vzorec.Text = "Globální minimum v Df<-5,12;...;5,12> je f(x) = 0 na pozici x=(0;...; 0).";
                    textBoxpocetNumDimenzi.Visible = true; labelpocetdimenziNum.Visible = true;
                    break;
                case 3:
                    label_vzorec.Text = "Globální minimum v Df<-100; 100> je f(x) = -1 na pozici x=(π; π).";
                    Swarm.pocetDimenzi = 2;textBoxpocetNumDimenzi.Visible = false; labelpocetdimenziNum.Visible = false;
                    break;               
            }
        }

        private void NominalniData_MouseClick(object sender, MouseEventArgs e)
        {
            if ((NominalniData.Checked == true) && (RadioUmelaData.Checked == true)) { label_vzorec.Visible = false; comboBox_funkce.Visible = false;
            vlozitRealnaData.Visible = false; label_pocetDimenzi.Visible = true; textBox_pocetDimenzi.Visible = true; textBoxpocetNumDimenzi.Visible = false;
            labelpocetdimenziNum.Visible = false;}
            if ((NominalniData.Checked == true) && (RadioRealnaData.Checked == true)) { vlozitRealnaData.Visible = true; label_vzorec.Visible = false;
            comboBox_funkce.Visible = false; label_pocetDimenzi.Visible = false; textBox_pocetDimenzi.Visible = false; textBoxpocetNumDimenzi.Visible = false;
            labelpocetdimenziNum.Visible = false; }
            if (NominalniData.Checked == true) { comboBox_funkce.Visible = false; label_vzorec.Visible = false; comboBox_typ.Visible = false;
            labelmaxmin.Visible = false; textBoxpocetNumDimenzi.Visible = false;labelpocetdimenziNum.Visible = false;}
        }

        private void NumerickaData_MouseClick(object sender, MouseEventArgs e)
        {
            if ((NumerickaData.Checked == true) && (RadioUmelaData.Checked == true)) { label_vzorec.Visible = true; comboBox_funkce.Visible = true; vlozitRealnaData.Visible = false; label_pocetDimenzi.Visible = false; textBox_pocetDimenzi.Visible = false;  }
            if ((NumerickaData.Checked == true) && (RadioRealnaData.Checked == true)) { vlozitRealnaData.Visible = true; label_pocetDimenzi.Visible = false; textBox_pocetDimenzi.Visible = false;  }
            if (NumerickaData.Checked == true) { comboBox_typ.Visible = true; labelmaxmin.Visible = true; label_vzorec.Visible = true; comboBox_funkce.Visible = true; Swarm.pocetDimenzi = 2; }
        }

        private void BinarniData_MouseClick(object sender, MouseEventArgs e)
        {
            if ((BinarniData.Checked == true) && (RadioUmelaData.Checked == true))
            {
                label_vzorec.Visible = false; comboBox_funkce.Visible = false; vlozitRealnaData.Visible = false; label_pocetDimenzi.Visible = true; textBox_pocetDimenzi.Visible = true; textBoxpocetNumDimenzi.Visible = false;
                labelpocetdimenziNum.Visible = false;}
            if ((BinarniData.Checked == true) && (RadioRealnaData.Checked == true)) { vlozitRealnaData.Visible = true; label_vzorec.Visible = false; comboBox_funkce.Visible = false; label_pocetDimenzi.Visible = false; textBox_pocetDimenzi.Visible = false; textBoxpocetNumDimenzi.Visible = false; labelpocetdimenziNum.Visible = false; }
            if (BinarniData.Checked == true) { comboBox_funkce.Visible = false; label_vzorec.Visible = false; comboBox_typ.Visible = false; labelmaxmin.Visible = false; textBoxpocetNumDimenzi.Visible = false; labelpocetdimenziNum.Visible = false; }
        }

        private void RadioRealnaData_MouseClick(object sender, MouseEventArgs e)
        {
            if ((NumerickaData.Checked == true) && (RadioRealnaData.Checked == true)) { Swarm.pocetDimenzi = 2; vlozitRealnaData.Visible = true; label_pocetDimenzi.Visible = false; textBox_pocetDimenzi.Visible = false; label_vzorec.Visible = true; comboBox_funkce.Visible = true; }
            if ((BinarniData.Checked == true) && (RadioRealnaData.Checked == true)) { vlozitRealnaData.Visible = true; label_pocetDimenzi.Visible = false; textBox_pocetDimenzi.Visible = false; textBoxpocetNumDimenzi.Visible = false; labelpocetdimenziNum.Visible = false; }
            if ((NominalniData.Checked == true) && (RadioRealnaData.Checked == true)) { vlozitRealnaData.Visible = true; label_pocetDimenzi.Visible = false; textBox_pocetDimenzi.Visible = false; textBoxpocetNumDimenzi.Visible = false; labelpocetdimenziNum.Visible = false; }
        }

        private void RadioUmelaData_MouseClick(object sender, MouseEventArgs e)
        {
            if ((NumerickaData.Checked == true) && (RadioUmelaData.Checked == true)) { label_vzorec.Visible = true; comboBox_funkce.Visible = true; vlozitRealnaData.Visible = false; label_pocetDimenzi.Visible = false; textBox_pocetDimenzi.Visible = false; }
            if (NumerickaData.Checked == false) { label_vzorec.Visible = false; comboBox_funkce.Visible = false; Swarm.pocetDimenzi = 2; }
            if ((NominalniData.Checked == true) && (RadioUmelaData.Checked == true)) { label_vzorec.Visible = false; comboBox_funkce.Visible = false; vlozitRealnaData.Visible = false; label_pocetDimenzi.Visible = true; textBox_pocetDimenzi.Visible = true; textBoxpocetNumDimenzi.Visible = false; labelpocetdimenziNum.Visible = false; }
            if ((BinarniData.Checked == true) && (RadioUmelaData.Checked == true)) { label_vzorec.Visible = false; comboBox_funkce.Visible = false; vlozitRealnaData.Visible = false; label_pocetDimenzi.Visible = true; textBox_pocetDimenzi.Visible = true; textBoxpocetNumDimenzi.Visible = false; labelpocetdimenziNum.Visible = false; }     
        }

        private void vlozitRealnaData_Click(object sender, EventArgs e)
        {
            //vycisteni po predchozich datech
            FunctionBase.realnadatastore.Clear();
            realnadatastore.Clear();
            FunctionBase.realnadatastoreNominalni.Clear();
            realnadatastorenominalni.Clear();
            FunctionBase.realnadatastorebinarni.Clear();
            realnadatastorebinarni.Clear();
            //nastaveni typu pro nahravana data
            zvoltyp();
            try
            {
                DialogResult result = openFileDialog_Zdroj.ShowDialog();

                int Row = 0;
                int longestline = 0;
                string cestaZdroj = "C:\\";
                if (result == DialogResult.OK)
                {
                    cestaZdroj = openFileDialog_Zdroj.FileName;

                }
                StreamReader sr = new StreamReader(cestaZdroj);
                var line = new List<string[]>();

                while (!sr.EndOfStream)
                {
                    string[] Line = sr.ReadLine().Split(' ');
                    int l = Line.Length;
                    if (l > longestline) longestline = l;
                    line.Add(Line);
                    Row++;
                }
                Swarm.reseni = "";
                Swarm.vypis = new string[line.Count];
                Swarm.reseni += "Načtená data ";
                Swarm.reseni += Environment.NewLine;
                Swarm.reseni += "Počet dimenzí " + Row;
                Swarm.reseni += Environment.NewLine;
                for (int j = 0; j < line.Count; j++)
                {
                    switch (FunctionBase.typDat)
                    {
                        case 1:
                            for (int i = 0; i < line[j].Length; i++) { Swarm.vypis[j] += line[j][i] + " "; }
                            Swarm.reseni += Swarm.vypis[j];
                            Swarm.reseni += Environment.NewLine;
                            break;
                        case 3:
                            for (int i = 0; i < line[j].Length; i++) { Swarm.vypis[j] += line[j][i] + " "; }
                            Swarm.reseni += Swarm.vypis[j];
                            Swarm.reseni += Environment.NewLine;
                            break;
                        case 5:
                            for (int i = 0; i < line[j].Length; i++) { Swarm.vypis[j] += line[j][i] + " "; }
                            Swarm.reseni += Swarm.vypis[j];
                            Swarm.reseni += Environment.NewLine;
                            break;
                    }
                }

                if (FunctionBase.typDat == 1)
                {
                    for (int j = 0; j < Row; j++)
                    {
                        List<int> a = new List<int>();
                        for (int i = 0; i < longestline; i++)
                        {
                            if (i < line[j].Length)
                            {
                                a.Add(Convert.ToInt32(line[j][i]));
                            }
                        }
                        realnadatastore.Add(a);
                    }
                    FunctionBase.realnadatastore = realnadatastore;
                    Swarm.maxX = longestline - 1;
                    Swarm.minX = 0;
                    //Swarm.Dim = FunctionBase.realnadatastoreNominalni.Count;
                }
                if (FunctionBase.typDat == 3)
                {
                    for (int j = 0; j < Row; j++)
                    {
                        List<char> a = new List<char>();
                        for (int i = 0; i < longestline; i++)
                        {
                            if (i < line[j].Length)
                            {
                                a.Add(Convert.ToChar(line[j][i]));
                            }
                        }
                        realnadatastorenominalni.Add(a);
                    }
                    FunctionBase.realnadatastoreNominalni = realnadatastorenominalni;
                    Swarm.maxX = longestline - 1;
                    Swarm.minX = 0;
                    Swarm.pocetDimenzi = FunctionBase.realnadatastoreNominalni.Count;
                }
                if (FunctionBase.typDat == 5)
                {
                    for (int j = 0; j < Row; j++)
                    {
                        List<bool> a = new List<bool>();
                        for (int i = 0; i < longestline; i++)
                        {
                            if (i < line[j].Length)
                            {
                                if (line[j][i] == "0")
                                {
                                    a.Add(false);
                                }
                                else
                                {
                                    a.Add(true);
                                }
                            }
                        }
                        realnadatastorebinarni.Add(a);
                    }
                    FunctionBase.realnadatastorebinarni = realnadatastorebinarni;
                    Swarm.maxX = longestline - 1;
                    Swarm.minX = 0;
                    Swarm.pocetDimenzi = FunctionBase.realnadatastorebinarni.Count;
                }
            }
            catch {
                MessageBox.Show("Chyba: Nesprávný formát dat");
            }
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }

        public void nahrejnominalnirealnadata() 
        { 
        
        }

        public void zvoltyp() {
            if ((NumerickaData.Checked == true) && (RadioUmelaData.Checked == true)) FunctionBase.typDat = 0;
            if ((NumerickaData.Checked == true) && (RadioRealnaData.Checked == true)) FunctionBase.typDat = 1;
            if ((NominalniData.Checked == true) && (RadioUmelaData.Checked == true)) FunctionBase.typDat = 2;
            if ((NominalniData.Checked == true) && (RadioRealnaData.Checked == true)) FunctionBase.typDat = 3;
            if ((BinarniData.Checked == true) && (RadioUmelaData.Checked == true)) FunctionBase.typDat = 4;
            if ((BinarniData.Checked == true) && (RadioRealnaData.Checked == true)) FunctionBase.typDat = 5;
        }
        public bool generujuNominalni() {
            upravProUmelyData();
            Swarm.reseni = "";
            FunctionBase.realnadatastoreNominalni.Clear();
            realnadatastorenominalni.Clear();
            string textPD = textBox_pocetDimenzi.Text;
            Random rndb = new Random();
            try
            {
                double pocetRadku = Convert.ToDouble(textPD);
                if (pocetRadku < 2)
                {
                    MessageBox.Show("Zadejte hodnotu 2 a vyšší");
                    return false;
                }
                else
                {
                    Swarm.pocetDimenzi = Convert.ToInt32(Math.Round(pocetRadku));
                    int pocetSloupcu = Convert.ToInt32(Math.Round(Swarm.maxX - Swarm.minX));
                    for (int j = 0; j < pocetRadku; j++)
                    {
                        List<char> a = new List<char>();
                        for (int i = 0; i < pocetSloupcu; i++)
                        {
                            a.Add(Convert.ToChar(65 + rndb.Next(0, 4)));
                        }
                        realnadatastorenominalni.Add(a);
                    }
                    FunctionBase.realnadatastoreNominalni = realnadatastorenominalni;
                    Swarm.reseni += "Vygenerovaná nominalní data ";
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "Počet dimenzí " + pocetRadku;
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "Délka sekvence " + (Swarm.maxX - Swarm.minX);
                    Swarm.reseni += Environment.NewLine;
                    Swarm.vypis = new string[realnadatastorenominalni.Count];
                    for (int j = 0; j < realnadatastorenominalni.Count; j++)
                    {
                        for (int i = 0; i < realnadatastorenominalni[0].Count; i++)
                        {
                            Swarm.reseni += realnadatastorenominalni[j][i] + " ";
                            Swarm.vypis[j] += realnadatastorenominalni[j][i] + " ";
                        }
                        Swarm.reseni += Environment.NewLine;
                    }
                    return true;
                }
            }
            catch (FormatException e)
            {
                MessageBox.Show("Nesprávná hodnota počet dimenzi");
                return false;
            }           
        }

        public bool generujuBinarni() {
            upravProUmelyData();
            Swarm.reseni = "";
            FunctionBase.realnadatastorebinarni.Clear();
            realnadatastorebinarni.Clear();
            string textPD = textBox_pocetDimenzi.Text;
            Random rndb = new Random();
            int nahodnaHodnota;
            try
            {
                double pocetRadku = Convert.ToDouble(textPD);
                if (pocetRadku < 2)
                {
                    MessageBox.Show("Zadejte hodnotu 2 a vyšší");
                    return false;
                }
                else
                {
                    Swarm.pocetDimenzi = Convert.ToInt32(Math.Round(pocetRadku));
                    int pocetSloupcu = Convert.ToInt32(Math.Round(Swarm.maxX - Swarm.minX));
                    for (int j = 0; j < pocetRadku; j++)
                    {
                        List<bool> a = new List<bool>();
                        for (int i = 0; i < pocetSloupcu; i++)
                        {
                            nahodnaHodnota = rndb.Next(0, 2);
                            if (nahodnaHodnota == 1) a.Add(true);
                            else a.Add(false);
                        }
                        realnadatastorebinarni.Add(a);
                    }
                    FunctionBase.realnadatastorebinarni = realnadatastorebinarni;
                    Swarm.reseni += "Vygenerovaná nominalní data ";
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "Počet dimenzí " + pocetRadku;
                    Swarm.reseni += Environment.NewLine;
                    Swarm.reseni += "Délka sekvence " + (Swarm.maxX - Swarm.minX);
                    Swarm.reseni += Environment.NewLine;
                    Swarm.vypis = new string[realnadatastorebinarni.Count];
                    for (int j = 0; j < realnadatastorebinarni.Count; j++)
                    {
                        for (int i = 0; i < realnadatastorebinarni[0].Count; i++)
                        {
                            Swarm.reseni += Convert.ToInt32(realnadatastorebinarni[j][i]) + " ";
                            Swarm.vypis[j]+=Convert.ToInt32(realnadatastorebinarni[j][i]) + " ";
                        }
                        Swarm.reseni += Environment.NewLine;
                    }
                    return true;
                }
            }
            catch (FormatException e)
            {
                MessageBox.Show("Nesprávná hodnota počet dimenzi");
                return false;
            }
        }

        public void upravProUmelyData() { 
            //uprava aby nebyly zaporny pozice
            if (Swarm.minX < 0) {
                zapornaHodnotaSwarmPozice = Swarm.minX;
                Swarm.maxX = Math.Abs(Swarm.minX) + Swarm.maxX;
                Swarm.minX = 0;
            }
        }
        public void upravVysledky() {
          if (zapornaHodnotaSwarmPozice < 0) {
                Swarm.maxX = zapornaHodnotaSwarmPozice + Swarm.maxX;
                Swarm.minX = zapornaHodnotaSwarmPozice;
                int a = s.bestGlobalPozice.Length;
                for (int i = 0; i < a; i++) {
                    s.bestGlobalPozice[i] = s.bestGlobalPozice[i] + zapornaHodnotaSwarmPozice;
                }
                zapornaHodnotaSwarmPozice = 0;
            }
        }

        
    }
}
